SnapshotBar = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceDB-2.0", "AceEvent-2.0")
local self=SnapshotBar
local GetActionInfo=GetActionInfo
local tonumber=tonumber

local function tcount(tab)
	local n=0
	for _ in pairs(tab) do
		n=n+1
	end
	return n
 end


function SnapshotBar:OnInitialize()
	self:RegisterDB("SnapshotBarDB")
	self:RegisterDefaults("profile", {
		snapshot = {},
		logout=false,
		}
	)  

end

local function SaveBars()
	local tt={}
	for i=1,120 do
		local t={}
		local spelltype, spellid= GetActionInfo(i)
		t.id=spellid
		t.type=spelltype
		tt[i]=t
	end
	self.db.profile.snapshot=tt
end

local function RestoreBars()
	if not self.db.profile.snapshot then return end
	if tcount(self.db.profile.snapshot)==0 then return end
	for i=1,120 do
		local spelltype, spellid= GetActionInfo(i)
		if not (spellid==self.db.profile.snapshot[i].id and spelltype==self.db.profile.snapshot[i].type) then 
			local found=false
			for j=tonumber(i),120 do
				local spelltype2, spellid2= GetActionInfo(j)
				if self.db.profile.snapshot[i].id==spellid2 and self.db.profile.snapshot[i].type==spelltype2 then
					PickupAction(i)
					PickupAction(j)
					PlaceAction(i)
					found=true
					break
				end
			end
			if not found then 
				PickupAction(i)
				ClearCursor() 
				if self.db.profile.snapshot[i].type=="spell" then
					PickupSpell(self.db.profile.snapshot[i].id,BOOKTYPE_SPELL)
					PlaceAction(i)
				elseif self.db.profile.snapshot[i].type=="macro" then
					PickupMacro(self.db.profile.snapshot[i].id)
					PlaceAction(i)
				elseif self.db.profile.snapshot[i].type=="item" then
					for bag=1,NUM_BAG_SLOTS do
						for bagslot=1,GetContainerNumSlots(bag) do
							local link=GetContainerItemLink(bag,bagslot)
							if link then
								local itemid=select(2,strsplit(":", link))
								itemid=select(1,strsplit(":", itemid))
								if tonumber(itemid)==tonumber(self.db.profile.snapshot[i].id) then
									PickupContainerItem(bag,bagslot)
									PlaceAction(i)
								end
							end
						end
					end
				end
			end
		end
	end

end


function SnapshotBar:OnEnable()
	self:SetProfile("char")
	local options={
		type="group",
		args={
			save={
				name="Save current bars",
				desc="Save current bars",
				type="execute",
				order=10,
				func=function() SaveBars() end
			},
			restore={
				name="Restore your bars",
				desc="Restore your bars",
				type="execute",
				order=20,
				confirm=true,
				func=function()
					RestoreBars()
				end
			},
			logout={	
				name="Save on logout",
				desc="Save on logout",
				type="toggle",
				get=function() return self.db.profile.logout end,
				set=function(v) self.db.profile.logout=v end,
				order=30,
			}
		}
	}
	self:RegisterChatCommand('/snap', options)
	self:RegisterEvent("PLAYER_LEAVING_WORLD")
end

function SnapshotBar:PLAYER_LEAVING_WORLD()
	if self.db.profile.logout then SaveBars() end
end

